<script lang="ts">
  import { Button, Form, FormGroup, Input, InputGroup, InputGroupText, Label, Spinner, Table } from '@sveltestrap/sveltestrap';
  import { getNotificationsContext } from 'svelte-notifications';
  import ENV from '@env';
  import axios from 'axios';
  import { keycloak } from '@stores';
  import type { TapiEventExport, TapiEventTeam } from '@models/Tapi';
  import { Gql } from '@db';
  import type { EventConfiguration } from '@models/EventConfigurations';
  import type { Team } from '@models/Team';
  import { EventRole } from '@auth/models';

  const { addNotification } = getNotificationsContext();
  const teamNamePrefix = 'Team';
  let importing = false;
  let queryRole = $keycloak?.getFirstRole([EventRole.EventAdmin]);
  let addTestTeam = true;
  let environment = '';
  let testTeamUser = 'de7d3f02-a586-4d8c-b8da-51f6e443f992'; // blue dude default
  let testTeamId = 0;
  let idOffset = 1;
  let tapiUrl = ENV.TapiUri;
  let selectedEvent: TapiEventTeam | null = null;
  let evtExport: TapiEventExport | null = null;
  let tapiApi;
  $: tapiApi = axios.create({ baseURL: tapiUrl });
  // ensure that idOffset is a number. Svelte is smart enough to not loop infinitely (hopefully)
  $: idOffset = parseInt(idOffset as string);

  async function getTapiApi<T = unknown>(url: string): Promise<T> {
    try {
      const response = await tapiApi.get(url, {
        headers: {
          Authorization: `Bearer ${$keycloak?.token}`,
        },
      });
      if (response?.data) return response.data;
      return response;
    } catch (e) {
      addNotification({
        text: `Failed to fetch TAPI API ${e}`,
        position: 'bottom-right',
        type: 'error',
        removeAfter: 5000,
      });
    }
  }

  async function getTapiEvents() {
    return getTapiApi('/v1/events');
  }

  async function getTapiEventExport(eventId): Promise<TapiEventExport | null> {
    evtExport = eventId ? await getTapiApi(`/v1/events/${eventId}/export`) : null;
    return evtExport;
  }

  async function handleImportTeams() {
    if (!evtExport) return;
    importing = true;
    try {
      await importTeams(evtExport);
    } finally {
      importing = false;
    }
  }

  async function importTeams(evt: TapiEventExport) {
    if (!environment.trim()) {
      addNotification({
        text: `Environment is required field`,
        position: 'bottom-right',
        type: 'error',
        removeAfter: 5000,
      });
      return;
    }
    // insert event
    addNotification({
      text: 'Inserting Event',
      position: 'bottom-right',
      removeAfter: 1000,
    });
    let eventStart = new Date(evt.startsOn);
    let eventEnd = new Date(eventStart.getTime() + 7 * 3600 * 1000); // 7 hours after start
    let eventGql = `{
      name: ${JSON.stringify(evt.name)},
      start: ${JSON.stringify(eventStart.toISOString())},
      end: ${JSON.stringify(eventEnd.toISOString())},
      environments: {
        data: {
          name: ${JSON.stringify(environment)}
        }
        on_conflict: {
          constraint: environment_name_key
          update_columns: [event_id]
        }
      }
    }`;
    const event = (
      await Gql.query<{ insert_events_one: EventConfiguration }>(
        `mutation TapiImportEvent {
          insert_events_one(object: ${eventGql},
          on_conflict: {constraint: events_name_key, update_columns: [name, start, end]}) {
            end
            id
            name
            start
          }
        }`,
        { queryRole },
      )
    ).insert_events_one;
    console.debug('event inserted', event);

    addNotification({
      text: `Removing All Membership for event ${event.id} (excluding ${teamNamePrefix}${testTeamId})`,
      position: 'bottom-right',
      removeAfter: 2000,
    });

    const removedTeams = await Gql.query<{ delete_team_membership: { affected_rows: number } }>(
      `mutation TapiImportRemoveMembership {
        delete_team_membership(
          where: {
            team: {
              events: {event_id: {_eq: ${JSON.stringify(event.id)}}},
              name: {_neq: "${teamNamePrefix}${testTeamId}"}
            }
        }) {
         affected_rows
        }
      }`,
      { queryRole },
    );

    console.warn(`removed ${removedTeams.delete_team_membership.affected_rows} Members`);
    addNotification({
      text: `Removed ${removedTeams.delete_team_membership.affected_rows} Members`,
      position: 'bottom-right',
      removeAfter: 2000,
    });

    // insert teams
    addNotification({
      text: 'Inserting Teams',
      position: 'bottom-right',
      removeAfter: 2000,
    });
    const teamsGql = evt.eventTeams
      .map(
        (t, i) => `{
        name: "${teamNamePrefix}${i + idOffset}",
        tapi_id: ${t.id},
        long_name: ${JSON.stringify(t.name)}
       }`,
      )
      .join(',');
    const teams: Team[] = (
      await Gql.query<{ insert_teams: { returning: Team[] } }>(
        `mutation TapiImportTeams {
        insert_teams(objects: [${teamsGql}], on_conflict: {constraint: teams_tapi_id_key, update_columns: [name, long_name]}) {
          returning {
            id
            name
            tapi_id
          }
        }
      }
    `,
        { queryRole },
      )
    ).insert_teams.returning;
    console.debug('teams inserted', teams);

    const teamMembership = [];
    for (let team of teams) {
      const eventTeam = evt.eventTeams.find((t) => t.id === team.tapi_id);
      for (let user of eventTeam.eventTeamUsers.map((et) => et.user)) {
        teamMembership.push({ team_id: team.id, user_id: user.keycloakSid });
      }
    }

    const teamMembershipGql = teamMembership.map(
      (t) => `{ team_id: ${JSON.stringify(t.team_id)}, user_id: ${JSON.stringify(t.user_id)} }`,
    );

    const eventRegistrationGql = teams.map(
      (t) => `{ team_id: ${JSON.stringify(t.id)}, event_id: ${JSON.stringify(event.id)} }`,
    );

    const teamSettingsGql = teams.map(
      (t, i) => `{
          team_id: ${JSON.stringify(t.id)},
          event_id: ${JSON.stringify(event.id)},
          visible: true,
          order: ${i + idOffset}
        }`,
    );

    const teamVars = teams.map((t, i) => {
      return {
        team_id: t.id,
        vars: { id: i + idOffset },
      };
    });

    addNotification({
      text: 'Inserting Team Registration, Membership, Variables, and Settings',
      position: 'bottom-right',
      removeAfter: 4000,
    });

    // insert event settings
    await Gql.query(
      `mutation TapiImportEventAndTeamSettings($teamVars: [variables_team_insert_input]!) {
        insert_team_membership(
          objects: [${teamMembershipGql.join(',')}],
          on_conflict: {constraint: team_membership_pkey}
        ) {
          affected_rows
        }

        insert_event_registration(
          objects: [${eventRegistrationGql.join(',')}],
          on_conflict: {constraint: event_registration_pkey}
        ) {
          affected_rows
        }

        insert_scoreboard_team_settings(
          objects: [${teamSettingsGql.join(',')}],
          on_conflict: {constraint: team_settings_pkey, update_columns: [visible, order]})
        {
          affected_rows
        }

        insert_variables_team(
          objects: $teamVars,
          on_conflict: {constraint: team_pkey}
        ) {
          affected_rows
        }
      }`,
      { queryRole, variables: { teamVars } },
    );

    addNotification({
      text: 'Event Imported Successfully!',
      position: 'bottom-right',
      type: 'success',
    });

    if (addTestTeam) await insertTestTeam(event.id);
  }

  async function getTestTeam(teamName): Promise<Team | null> {
    const data = await Gql.query<{ teams: Team[] }>(
      `query TapiGetTestTeam {
        teams(
          where: { name: { _eq: ${JSON.stringify(teamName)} } },
        ) {
          id
          name
        }
      }
    `,
      { queryRole },
    );
    if (data.teams.length > 0) return data.teams[0];
    return null;
  }

  async function insertTestTeam(eventId: string) {
    // insert team
    const teamName = `${teamNamePrefix}${testTeamId}`;
    addNotification({
      text: `Inserting Test Team '${teamName}'`,
      position: 'bottom-right',
      removeAfter: 2000,
    });

    let team = await getTestTeam(teamName);

    if (!team) {
      team = (
        await Gql.query<{ insert_teams_one: Team }>(
          `mutation TapiImportTestTeam {
          insert_teams_one(
            object: { name: ${JSON.stringify(teamName)} }
          ) {
            id
            name
            tapi_id
          }
        }
      `,
          { queryRole },
        )
      ).insert_teams_one;
    }

    await Gql.query(
      `mutation TapiImportTestTeamSettings($teamVars: [variables_team_insert_input]!) {
        insert_team_membership(
          objects: { team_id: ${JSON.stringify(team.id)}, user_id: ${JSON.stringify(testTeamUser)} },
          on_conflict: {constraint: team_membership_pkey, update_columns: user_id}
        ) {
          affected_rows
        }

        insert_event_registration(
          objects: { team_id: ${JSON.stringify(team.id)}, event_id: ${JSON.stringify(eventId)} },
          on_conflict: {constraint: event_registration_pkey}
        ) {
          affected_rows
        }

        insert_scoreboard_team_settings(
          objects: {
            team_id: ${JSON.stringify(team.id)},
            event_id: ${JSON.stringify(eventId)},
            visible: false,
            order: 0
          },
          on_conflict: {constraint: team_settings_pkey, update_columns: [visible, order]})
        {
          affected_rows
        }

        insert_variables_team(
          objects: $teamVars,
          on_conflict: {constraint: team_pkey},
        ) {
          affected_rows
        }
      }`,
      {
        queryRole,
        variables: {
          teamVars: [
            {
              team_id: team.id,
              vars: {
                id: testTeamId,
              },
            },
          ],
        },
      },
    );
    addNotification({
      text: 'Test Team Inserted',
      type: 'success',
      position: 'bottom-right',
      removeAfter: 2000,
    });
  }
</script>

<Form on:submit={handleImportTeams}>
  <FormGroup>
    <InputGroup class="mb-3">
      <InputGroupText>TAPI URL:</InputGroupText>
      <Input required class="bg-white text-dark" bind:value={tapiUrl} />
    </InputGroup>

    <InputGroup class="mb-3">
      <InputGroupText class=" bg-secondary">
        <Input class="clickable align-self-center" type="switch" bind:checked={addTestTeam} label="Insert Test Team" />
      </InputGroupText>
      {#if addTestTeam}
        <InputGroupText>Test Team ID</InputGroupText>
        <Input class="bg-white text-dark" type="number" required={addTestTeam} bind:value={testTeamId} />
        <InputGroupText>Test Team User SID</InputGroupText>
        <Input class="bg-white text-dark" required={addTestTeam} bind:value={testTeamUser} />
      {/if}
    </InputGroup>

    <InputGroup class="mb-3">
      <InputGroupText>Environment</InputGroupText>
      <Input required placeholder="e.g. vce1, vce2" class="bg-white text-dark" bind:value={environment} />
      <InputGroupText>Starting Team ID - VCE1=1, VCE2=13</InputGroupText>
      <Input required type="number" class="bg-white text-dark" bind:value={idOffset} />
    </InputGroup>

    {#key tapiUrl}
      {#await getTapiEvents() then events}
        <FormGroup>
          <Label>Event</Label>
          <Input required type="select" name="select" bind:value={selectedEvent}>
            {#each events as evt}
              <option value={evt}>{evt.name}</option>
            {/each}
          </Input>
        </FormGroup>
      {/await}
    {/key}

    {#if selectedEvent}
      <h3>The following teams will be imported:</h3>
      {#await getTapiEventExport(selectedEvent?.id)}
        <Spinner />
      {:then _}
        <Table>
          <thead>
            <tr>
              <td>Tapi ID</td>
              <td>Scoreboard Team</td>
              <td>Name</td>
              <td>Captain</td>
              <td>Members</td>
            </tr>
          </thead>
          <tbody>
            {#each evtExport.eventTeams as team, i}
              <tr>
                <td>{team.id}</td>
                <td>Team{idOffset + i}</td>
                <td>{team.name}</td>
                <td>{team.eventTeamUsers.find((tu) => tu.userId === team.createdByUserId)?.user.email}</td>
                <td>
                  {#each team.eventTeamUsers as user}
                    <p>{user.user.email}</p>
                  {/each}
                </td>
              </tr>
            {/each}
          </tbody>
        </Table>

        <Button disabled={importing} color="success" type="submit">
          {#if importing}
            <Spinner />
          {:else}
            Continue
          {/if}
        </Button>
      {/await}
    {/if}
  </FormGroup>
</Form>
